import java.util.function.Consumer;

public class LL<E> {
	final LL<E> tail;
	final E head;
	public LL(E rechteHand, LL<E> linkeHand ) {
		this.tail = linkeHand;
		this.head = rechteHand;
	}
	public LL() {
		this(null,null);
	}
	boolean isEmpty() {
		return tail==null && head==null;
	}
	int laenge() {
		if (isEmpty())return 0;
		var leftResult = tail.laenge();
		return 1+leftResult;
	}
	boolean contains(E e) {
		if (isEmpty())return false;
		if (head.equals(e)) return true;
		return tail.contains(e);
	}
	void machtAlleWas(Consumer<E> consumer) {
		if (isEmpty())return;
		tail.machtAlleWas(consumer);
		consumer.accept(head);
	}
	
}
